    // Select.prg
    //
    // Select many records from a database
    // Creates array containing selected record numbers
    //
    // Compile with /a /m /n /w

    #include "inkey.ch"

    // Default column separator
    #define DEF_CSEP  " " + chr(179) + " "

    // Default heading separator
    #define DEF_HSEP chr(205) + chr(209) + chr(205)

    // Default footing separator
    #define DEF_FSEP chr(205) + chr(207) + chr(205)


    FUNCTION Tb02

    FIELD Lname, Fname, Addr1, Addr2, Addr3, Addr4 IN TbDbf1

    LOCAL oTbr  := TBrowseDb(1, 1, maxRow() - 1, maxCol() - 1)
    LOCAL oTbc1 := TBColumnNew("Last name",  {|| lname })
    LOCAL oTbc2 := TBColumnNew("First name", {|| fname })
    LOCAL oTbc3 := TBColumnNew("Address 1",  {|| addr1 })
    LOCAL oTbc4 := TBColumnNew("Address 2",  {|| addr2 })
    LOCAL oTbc5 := TBColumnNew("Address 3",  {|| addr3 })
    LOCAL oTbc6 := TBColumnNew("Address 4",  {|| addr4 })
    LOCAL nKey
    LOCAL lExitRequested
    LOCAL aSelected := {}
    LOCAL oTbcSelect
    LOCAL i

      oTbcSelect := TBColumnNew(, {|| iif(Ascan(aSelected, Recno()) > 0, ;
                                          " X ", "   ") })

      oTbr:colSep  := DEF_CSEP
      oTbr:headSep := DEF_HSEP
      oTbr:footSep := DEF_FSEP

      CLEAR SCREEN
      @ 0, 0 TO MaxRow(), MaxCol()

      USE tbdbf1
      IF !file("tbdbf1.ntx")
        INDEX ON upper(lname + fname) TO tbdbf1
      ELSE
        SET INDEX TO tbdbf1
      ENDIF

      oTbr:addColumn(oTbcSelect)
      oTbr:addColumn(TBColumnNew("Record #", {|| recno() }))
      oTbr:addColumn(oTbc1)
      oTbr:addColumn(oTbc2)
      oTbr:addColumn(oTbc3)
      oTbr:addColumn(oTbc4)
      oTbr:addColumn(oTbc5)
      oTbr:addColumn(oTbc6)

      lExitRequested := .F.
      DO WHILE !lExitRequested
        DO WHILE !oTbr:stabilize()
        ENDDO
        nKey := inkey(0)

        DO CASE
          CASE nKey == K_DOWN;       oTbr:down()
          CASE nKey == K_UP;         oTbr:up()
          CASE nKey == K_PGDN;       oTbr:pagedown()
          CASE nKey == K_PGUP;       oTbr:pageup()
          CASE nKey == K_CTRL_PGUP;  oTbr:gotop()
          CASE nKey == K_CTRL_PGDN;  oTbr:gobottom()
          CASE nKey == K_RIGHT;      oTbr:right()
          CASE nKey == K_LEFT;       oTbr:left()
          CASE nKey == K_HOME;       oTbr:home()
          CASE nKey == K_END;        oTbr:end()
          CASE nKey == K_CTRL_LEFT;  oTbr:panleft()
          CASE nKey == K_CTRL_RIGHT; oTbr:panright()
          CASE nKey == K_CTRL_HOME;  oTbr:panhome()
          CASE nKey == K_CTRL_END;   oTbr:panend()
          CASE nKey == K_ENTER;      recSelect(aSelected)
                                     oTbr:refreshCurrent()
          CASE nKey == K_ESC;        lExitRequested := .T.
        ENDCASE
      ENDDO

      CLEAR SCREEN

      Asort(aSelected,,, {|n1, n2| CompLnames(n1, n2) })

      FOR i := 1 TO Len(aSelected)
        GOTO aSelected[i]
        ? i, aSelected[i], Lname
      NEXT
      Inkey(0)

    RETURN NIL


    FUNCTION recSelect(aSelected)

    LOCAL nElem := ascan(aSelected, recno())

      IF nElem > 0
        adel(aSelected, nElem)
        asize(aSelected, len(aSelected) - 1)
      ELSE
        aadd(aSelected, Recno())
      ENDIF
      
    RETURN NIL

    FUNCTION CompLnames(n1, n2)

    FIELD Lname IN TbDbf1
    LOCAL cSaveLname

      GOTO n1
      cSaveLname := Lname

      GOTO n2

    RETURN cSaveLname <= Lname
